structure BinaryTree_TacticStyle_Code : sig
  datatype num = One | Bit0 of num | Bit1 of num
  datatype inta = Zero_int | Pos of num | Neg of num
  datatype nat = Zero_nat | Suc of nat
  val plus_nat : nat -> nat -> nat
  val nat_of_num : num -> nat
  val nat : inta -> nat
  val less_nat : nat -> nat -> bool
  val less_eq_nat : nat -> nat -> bool
  val equal_nat : nat -> nat -> bool
  datatype tree = Tip | Nd of tree * nat * tree
  val equal_tree : tree -> tree -> bool
  val rm : tree -> nat
  val rem : tree -> tree
  val memb : nat -> tree -> bool
  val remove : nat -> tree -> tree
  val binsert : nat -> tree -> tree
  val test : bool
end = struct

datatype num = One | Bit0 of num | Bit1 of num;

datatype inta = Zero_int | Pos of num | Neg of num;

datatype nat = Zero_nat | Suc of nat;

fun plus_nat (Suc m) n = plus_nat m (Suc n)
  | plus_nat Zero_nat n = n;

fun nat_of_num One = Suc Zero_nat
  | nat_of_num (Bit0 x) = plus_nat (nat_of_num x) (nat_of_num x)
  | nat_of_num (Bit1 x) = Suc (plus_nat (nat_of_num x) (nat_of_num x));

fun nat (Pos k) = nat_of_num k
  | nat Zero_int = Zero_nat
  | nat (Neg k) = Zero_nat;

fun less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false
and less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true;

fun equal_nat (Suc nat) Zero_nat = false
  | equal_nat Zero_nat (Suc nat) = false
  | equal_nat (Suc nata) (Suc nat) = equal_nat nata nat
  | equal_nat Zero_nat Zero_nat = true;

datatype tree = Tip | Nd of tree * nat * tree;

fun equal_tree (Nd (tree1, nat, tree2)) Tip = false
  | equal_tree Tip (Nd (tree1, nat, tree2)) = false
  | equal_tree (Nd (tree1a, nata, tree2a)) (Nd (tree1, nat, tree2)) =
    equal_tree tree1a tree1 andalso
      (equal_nat nata nat andalso equal_tree tree2a tree2)
  | equal_tree Tip Tip = true;

fun rm (Nd (l, x, r)) = (if equal_tree r Tip then x else rm r);

fun rem (Nd (l, x, r)) = (if equal_tree r Tip then l else Nd (l, x, rem r));

fun memb e Tip = false
  | memb e (Nd (t1, x, t2)) =
    (if less_nat e x then memb e t1
      else (if less_nat x e then memb e t2 else true));

fun remove x Tip = Tip
  | remove x (Nd (l, y, r)) =
    (if less_nat x y then Nd (remove x l, y, r)
      else (if less_nat y x then Nd (l, y, remove x r)
             else (if equal_tree l Tip then r else Nd (rem l, rm l, r))));

fun binsert x Tip = Nd (Tip, x, Tip)
  | binsert x (Nd (t1, y, t2)) =
    (if less_nat x y then Nd (binsert x t1, y, t2)
      else (if less_nat y x then Nd (t1, y, binsert x t2) else Nd (t1, y, t2)));

val test : bool =
  memb (nat (Pos (Bit0 (Bit0 One))))
    (remove (nat (Pos (Bit1 One)))
      (binsert (nat (Pos (Bit0 (Bit0 One))))
        (binsert (nat (Pos (Bit1 One))) Tip)));

end; (*struct BinaryTree_TacticStyle_Code*)
